/**
 * Author: S. Smith
 * Revised: March 17, 2009
 * 
 * Description: Edge ADT class
 */

import static java.lang.Math.*;

public class EdgeT 
{

   public static final double TOLERANCE = 1e-5;

   private NodeT n1;

   private NodeT n2;

   public EdgeT(NodeT nod1, NodeT nod2)
   {
     n1 = nod1;
     n2 = nod2;
   }

   public NodeT node1()
   {
     return n1;
   }

   public NodeT node2()
   {
     return n2;
   }

   public double length()
   {
     return n1.dist(n2);
   }

   public boolean is_horizontal()
   {
     return abs(n1.ycoord() - n2.ycoord()) <= TOLERANCE;
   }

   public boolean equal(EdgeT e)
   {
     return (n1.equal(e.node1()) && n2.equal(e.node2())) || (n1.equal(e.node2()) && n2.equal(e.node1())) ;
   }

}
